function [ukk] = FN(uki)

global K1 K2 N nu KK1 T nT h tt...
    LE NLE D1 D2 P1 P2 F nl fk dk nl

uk=uki;

    %% Linear bit
    
    if nl==1
        %% Nonlinear bit
        ud1kt=D1.*uk;
        ud2kt=D2.*uk;
        %     ud1kt=D1.*uk;
        %     ud2kt=D2.*uk;

        ud1k1t=P1.*ud1kt;
        ud1k2t=P2.*ud1kt;
        
        ud2k1t=P1.*ud2kt;
        ud2k2t=P2.*ud2kt;
        
        uk1t=P1.*uk;
        uk2t=P2.*uk;
        %     ud1kt=D1.*uk;
        %     ud2kt=D2.*uk;
        
        u1tmk=[0*[uk1t(1:N/2,:),uk1t(1:N/2,:)]; ...
            [0*uk1t(:,1:N/2),F.*uk1t,0*uk1t(:,1:N/2)]; ...
            0*[uk1t(1:N/2,:),uk1t(1:N/2,:)]];
        u2tmk=[0*[uk1t(1:N/2,:),uk1t(1:N/2,:)]; ...
            [0*uk1t(:,1:N/2),F.*uk2t,0*uk1t(:,1:N/2)]; ...
            0*[uk1t(1:N/2,:),uk1t(1:N/2,:)]];
        
        u1tt=4*N^2*ifft2(ifftshift(u1tmk));
        u2tt=4*N^2*ifft2(ifftshift(u2tmk));
        
        ud11mk=[0*[uk1t(1:N/2,:),uk1t(1:N/2,:)]; ...
            [0*uk1t(:,1:N/2),F.*ud1k1t,0*uk1t(:,1:N/2)]; ...
            0*[uk1t(1:N/2,:),uk1t(1:N/2,:)]];
        ud12mk=[0*[uk1t(1:N/2,:),uk1t(1:N/2,:)]; ...
            [0*uk1t(:,1:N/2),F.*ud1k2t,0*uk1t(:,1:N/2)]; ...
            0*[uk1t(1:N/2,:),uk1t(1:N/2,:)]];
        ud21mk=[0*[uk1t(1:N/2,:),uk1t(1:N/2,:)]; ...
            [0*uk1t(:,1:N/2),F.*ud2k1t,0*uk1t(:,1:N/2)]; ...
            0*[uk1t(1:N/2,:),uk1t(1:N/2,:)]];
        ud22mk=[0*[uk1t(1:N/2,:),uk1t(1:N/2,:)]; ...
            [0*uk1t(:,1:N/2),F.*ud2k2t,0*uk1t(:,1:N/2)]; ...
            0*[uk1t(1:N/2,:),uk1t(1:N/2,:)]];
        
        ud11t=4*N^2*ifft2(ifftshift(ud11mk));
        ud12t=4*N^2*ifft2(ifftshift(ud12mk));
        ud21t=4*N^2*ifft2(ifftshift(ud21mk));
        ud22t=4*N^2*ifft2(ifftshift(ud22mk));
        
        u1t=u1tt.*ud11t+u2tt.*ud21t;
        u2t=u1tt.*ud12t+u2tt.*ud22t;
        
        u1tmk=1/4/N^2*fftshift(fft2(u1t));
        u2tmk=1/4/N^2*fftshift(fft2(u2t));

        
        uk1n=F.*u1tmk(N/2+1:3*N/2,N/2+1:3*N/2);
        uk2n=F.*u2tmk(N/2+1:3*N/2,N/2+1:3*N/2);
        ukn=(P1.*uk1n+P2.*uk2n);

    else
        ukn=0;
    end
    
    ukNL=(ukn+fk);
    
    
    uk=ukNL;
    ukk=KK1*uk*KK1;
    
